package pg;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.util.Vector;

@SuppressWarnings("serial")
public class BezierCurvatura extends Canvas {

	private Vector<Ponto> pontos;

	public BezierCurvatura(Vector<Ponto> pontos) {

		this.pontos = pontos;
		setBackground(Color.BLACK);
	}

	public void addPonto(Ponto ponto) {
		this.pontos.add(ponto);
	}

	public void desenharGrafico() {

		Graphics g = getGraphics();
		System.out.println("teste");
		for(int i = 0; i < pontos.size(); i++){
			Grafico.desenhaPontoCurvatura(g, pontos.get(i), Color.GREEN);
		}

		g.setColor(Color.WHITE);
		g.drawLine(0, 250, 550, 250);//eixo X
		g.drawLine(275, 0, 275, 500);//eixo Y
	}

	public void refazerGrafico() {
		Graphics g = getGraphics();
		Grafico.desenhaPoligonoCurvatura(g, pontos, getBackground());	
	}

	public void paint(Graphics g) {

		if (pontos.size() >= 2) {
			desenharGrafico();
		} else {
			g.drawLine(0, 250, 550, 250);//eixo X
			g.drawLine(275, 0, 275, 500);//eixo Y
		}
	}

	public void setNovosPontos(Vector<Ponto> pontos) {

		this.pontos = pontos;
		this.repaint();

	}

	public Vector<Ponto> getPontos() {
		return this.pontos;
	}
}
