package pg;

import java.awt.Color;
import java.awt.Graphics;
import java.util.Vector;

class Grafico {

	public static void desenhaPonto(Graphics g, Ponto ponto, Color color) {
		g.setColor(color);
		g.fillOval((int) Math.round(ponto.getX()) - 1, (int) Math.round(ponto
				.getY()) - 1, 7, 7);
	}
	
	public static void desenhaPontoCurvatura(Graphics g, Ponto ponto, Color color){
		g.setColor(color);
		
		g.fillOval((int) Math.round(ponto.getX()*200-4)+275, 210 - (int) Math.round(ponto
				.getY()*100000-4), 7, 7);
		System.out.println((int) Math.round(ponto.getX()*10-4)+295);
		System.out.println(250 - (int) Math.round(ponto.getY()*100000-4));
		
		g.setColor(Color.WHITE);
		g.fillOval((int) Math.round(ponto.getX()*200-4)+275, 250-4, 7, 7);
		
		g.drawLine((int) Math.round(ponto.getX()*200)+275, 210 - (int) Math.round(ponto
				.getY()*100000),(int) Math.round(ponto.getX()*200)+275, 250);
	}

	public static void desenhaPoligono(Graphics g, Vector<Ponto> p, Color color) {
		g.setColor(color);
		for (int i = 0; i < p.size() - 1; ++i) {
			g.drawLine((int) Math.round(p.get(i).getX()), (int) Math.round(p
					.get(i).getY()), (int) Math.round(p.get(i + 1).getX()),
					(int) Math.round(p.get(i + 1).getY()));
		}
	}
	
	public static void desenhaPoligonoCurvatura(Graphics g, Vector<Ponto> p, Color color){
		g.setColor(color);
		for (int i = 0; i < p.size() - 1; ++i) {
			g.drawLine((int) Math.round(p.get(i).getX()), (int) Math.round(p
					.get(i).getY()), (int) Math.round(p.get(i + 1).getX()),
					(int) Math.round(p.get(i + 1).getY()));
		}
	}

	private static void imprimirCurva(Graphics g, Vector<Ponto> pCurva,
			Vector<Ponto> pControle) {
		int tamanho = pCurva.size();

		g.drawLine((int) Math.round(pControle.get(0).getX()), (int) Math
				.round(pControle.get(0).getY()), (int) Math.round(pCurva.get(0)
				.getX()), (int) Math.round(pCurva.get(0).getY()));

		for (int i = 0; i < tamanho - 1; i++) {
			int x1 = (int) Math.round(pCurva.get(i).getX());
			int y1 = (int) Math.round(pCurva.get(i).getY());
			int x2 = (int) Math.round(pCurva.get(i + 1).getX());
			int y2 = (int) Math.round(pCurva.get(i + 1).getY());

			g.drawLine(x1, y1, x2, y2);
		}
		int ultimoPCurv = pCurva.size() - 1;
		int ultimoPCont = pControle.size() - 1;
		g.drawLine((int) Math.round(pCurva.get(ultimoPCurv).getX()), (int) Math
				.round(pCurva.get(ultimoPCurv).getY()), (int) Math
				.round(pControle.get(ultimoPCont).getX()), (int) Math
				.round(pControle.get(ultimoPCont).getY()));
	}

	public static void calculaCurva(Graphics g, Vector<Ponto> pontos,
			Color color, int avaliacoes) {
		g.setColor(color);

		double incremento = (double) 1 / (avaliacoes + 1);

		Vector<Ponto> pontosNaCurva = new Vector<Ponto>();
		pontosNaCurva.add(pontos.get(0));
		for (double i = incremento; i < 1; i = i + incremento) {
			Ponto pontoDaVez = bezier(pontos, i);
			pontosNaCurva.add(pontoDaVez);
		}
		pontosNaCurva.add(pontos.get(pontos.size() - 1));
		imprimirCurva(g, pontosNaCurva, pontos);
	}

	public static Vector<Ponto> pontosDaCurvatura(Vector<Ponto> pontosDeControle){
		Vector<Ponto> pontosCurvatura = new Vector<Ponto>();
		
		 double incremento = 0.01;
		 for(double i = incremento; i < 1; i = i + incremento){
			 Ponto ponto = Grafico.pontoDaCurvatura(i,pontosDeControle);
			 pontosCurvatura.add(ponto);
			 System.out.println(ponto.getX() + "/ " + ponto.getY()*100000);
		 }
		 
		return pontosCurvatura;
	}
	
	private static Ponto bezier(Vector<Ponto> pontosControle, double t) {
		int grau = pontosControle.size() - 1;

		Ponto p = new Ponto(0, 0);
		for (int i = 0; i < pontosControle.size(); i++) {
			Ponto pontoDaVez = pontosControle.get(i);
			p = p.soma(pontoDaVez.mult(calculaB(t, grau, i)));
		}
		return p;
	}

	private static double calculaB(double t, int n, int i) {
		return (combinacao(n, i) * (Math.pow((1 - t), (n - i))) * (Math.pow(t,
				i)));
	}

	private static Double calculaPontoIntermediario(
			Vector<Ponto> pontosControle, double t, int r, int i) {

		double y = 0;

		for (int j = 0; j <= r; j++) {

			y = y + (pontosControle.get(i + j).getY()) * (calculaB(t, r, j));

		}
		return y;
	}
	
	private static double primeiraDerivada(Vector<Ponto> pontosControle,
			double t) {

		int n = pontosControle.size() - 1;

		double y = calculaPontoIntermediario(pontosControle, t, n - 1, 1)
				- calculaPontoIntermediario(pontosControle, t, n - 1, 0);
		y = y * n;
		return y;

	}

	private static double segundaDerivada(Vector<Ponto> pontosControle, double t) {
		int n = pontosControle.size() - 1;

		double y = (calculaPontoIntermediario(pontosControle, t, n - 2, 2))
				- (2 * (calculaPontoIntermediario(pontosControle, t, n - 2, 1)))
				+ (calculaPontoIntermediario(pontosControle, t, n - 2, 0));
		y = y * ((Math.pow(n, 2)) - n);
		return y;
	}

	private static Ponto pontoDaCurvatura(double t,
			Vector<Ponto> pontosDeControle) {
		Ponto pontoRetorno = new Ponto(0, 0);
		pontoRetorno.setX(t);

		double numerador;
		numerador = segundaDerivada(pontosDeControle, t);

		double denominador;
		denominador = (Math.pow(((Math.pow((primeiraDerivada(pontosDeControle,
				t)), 2)) + 1), 1.5));

		double y = (numerador / denominador);

		pontoRetorno.setY(y);

		return pontoRetorno;
	}
	
	private static int fatorial(int n) {
		int retorno = -1;

		if (n >= 0) {
			retorno = 1;
			for (int i = 2; i <= n; i++) {
				retorno = retorno * i;
			}
		}
		return retorno;
	}

	private static int combinacao(int n, int p) {
		return fatorial(n) / (fatorial(p) * fatorial(n - p));
	}
}
