package pg;

import java.util.Vector;

import javax.swing.JFrame;

@SuppressWarnings("serial")
public class JanelaCurvatura extends JFrame {

	private BezierCurvatura canvas;
	public Vector<Ponto> pontosDeControle;
	Grafico grafico;

	public JanelaCurvatura(Vector<Ponto> pontosAntes) {
		this.pontosDeControle = Grafico.pontosDaCurvatura(pontosAntes);
		this.canvas = new BezierCurvatura(pontosDeControle);

		this.init();
	}

	private void init() {

		this.setTitle("Curva da curvatura");
		this.setLocation(400, 480);
		this.add("Center", this.canvas);
		this.setSize(550, 500);
		this.setResizable(false);

		this.setDefaultCloseOperation(EXIT_ON_CLOSE);

		this.setVisible(true);

	}

	public void addPonto(Ponto ponto) {
		this.pontosDeControle.add(ponto);
		this.canvas.addPonto(ponto);
	}

	public void setVetorPontos(Vector<Ponto> novosPontos) {

		this.pontosDeControle = Grafico.pontosDaCurvatura(novosPontos);
		this.canvas.setNovosPontos(pontosDeControle);

	}
}
