﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Drawing;
using System.Collections;

namespace WebApplication2.basicas
{
    public class Usuario
    {
        private string _nome;
        private string _sobrenome;
        private string _email;
        private string _login;
        private string _senha;
        private int _id;
        private int _sexo;
        private DateTime _nascimento;
        private Image _foto;
        public ArrayList _motivadores;
        public ArrayList _HistoricoAtividades;
        public ArrayList _HistoricoRefeicoes;
        public ArrayList _HistoricoMetas;
        public ArrayList _HistoricoPesos;

        
        public Usuario(string nome, string sobrenome, string email, string login, string senha, int sexo, DateTime nascimento, Image foto)
        {
            this._nome = nome;
            this._sobrenome = sobrenome;
            this._sexo = sexo;
            this._login = login;
            this._email = email;
            this._senha = senha;
            this._nascimento = nascimento;
            this._foto = foto;
            this._motivadores = new ArrayList();
            this._HistoricoAtividades = new ArrayList();
            this._HistoricoRefeicoes = new ArrayList();
            this._HistoricoMetas = new ArrayList();
            this._HistoricoPesos = new ArrayList();
        }

        
        #region Propriedades
        public int Id
        {
            get { return this._id; }
            set { this._id = value; }
        }
        public int Sexo
        {
            get { return this._sexo; }
            set { this._sexo = value; }
        }
        public DateTime Nascimento
        {
            get { return this._nascimento; }
            set { this._nascimento = value; }
        }
        public string Nome
        {
            get { return this._nome; }
            set { this._nome = value; }
        }
        public string Sobrenome
        {
            get { return this._sobrenome; }
            set { this._sobrenome = value; }
        }
        public string SenhaCliente
        {
            get { return this._senha; }
            set { this._senha = value; }
        }
        public string Email
        {
            get { return this._email; }
            set { this._email = value; }
        }
        public string Login
        {
            get { return this._login; }
            set { this._login = value; }
        }
        #endregion

        #region Metodos
        public void adicionarMotivador(Usuario motivador) 
        {
            this._motivadores.Add(motivador);
        }
        public void removerMotivador(int indece)
        {
            this._motivadores.Remove(indece);
        }
        public string getMotivador(int indice) 
        {
            return (string)this._motivadores[indice];
        }

        public void adicionarAtividade(Atividade atividade)
        {
            this._HistoricoAtividades.Add(atividade);
        }
        public void removerAtividade(int indice)
        {
            this._HistoricoAtividades.Remove(indice);
        }
        public Atividade getAtividade(int indice) 
        { 
            return (Atividade) this._HistoricoAtividades[indice];

        }

        public void adicionarPeso(Peso peso)
        {
            this._HistoricoPesos.Add(peso);
        }
        public void removerPeso(int indece)
        {
            this._HistoricoPesos.Remove(indece);
        }
        public Peso getPeso(int indice) 
        {
            return (Peso)this._HistoricoPesos[indice];
        }

        public void adicionarReficao(Refeicao refeicao)
        {
            this._HistoricoRefeicoes.Add(refeicao);
        }
        public void removerReficao(int indece)
        {
            this._HistoricoRefeicoes.Remove(indece);
        }
        public Refeicao getRefeicao(int indice) 
        {
            return (Refeicao)this._HistoricoRefeicoes[indice];
        }

        public void adicionarMeta(Meta refeicao)
        {
            this._HistoricoMetas.Add(refeicao);
        }
        public void removerMeta(int indece)
        {
            this._HistoricoMetas.Remove(indece);
        }
        public Meta getMeta(int indice) 
        {
            return (Meta)this._HistoricoMetas[indice];
        }
        #endregion

    }
}
